Index: trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchMessenger.cp
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchMessenger.cp	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchMessenger.cp	(revision 153)
@@ -0,0 +1,430 @@
+#include <Carbon/Carbon.h>
+#include <syslog.h> 
+#include <unistd.h> 
+#include "SCPatchPrivate.h"
+#include "SCPatchMessenger.h"
+
+//-------------------------------------------------------------------------------------------------------------
+SCPatchMessenger::SCPatchMessenger(void)
+{
+	mThreaded = false;
+	mMessagePort = NULL;
+	mMessageSource = NULL;
+	pthread_mutex_init(&mMessageQueueMutex, NULL);
+	mMessageRetryInterval = DEFAULT_MESSAGE_RETRY_INTERVAL;
+	mMessageRetryLimit = DEFAULT_MESSAGE_RETRY_LIMIT;
+	
+	mMessageQueueDict = CFDictionaryCreateMutable(NULL, 0, &kCFTypeDictionaryKeyCallBacks, NULL);
+	mMessageThreadDict = CFDictionaryCreateMutable(NULL, 0, NULL, &kCFTypeDictionaryValueCallBacks);
+}
+
+//-------------------------------------------------------------------------------------------------------------
+SCPatchMessenger::~SCPatchMessenger(void)
+{
+	CFRelease(mMessageQueueDict);
+	CFRelease(mMessageThreadDict);
+}
+
+//-------------------------------------------------------------------------------------------------------------
+OSErr SCPatchMessenger::StartListening(CFStringRef bundleIdentifier, 
+							Boolean isPatch, Boolean threaded)
+{
+	OSErr		 			err = noErr;
+	CFStringRef				messagePortName;
+	CFMessagePortContext	messageContext = { 0 };
+	Boolean					messageShouldFree;
+	EventLoopRef			mainLoop;
+	
+	mThreaded = threaded;
+	
+	// Create a port to receive messages
+	messageContext.info = this;
+	
+	if(isPatch)
+		messagePortName = CFStringCreateWithFormat(NULL, NULL, CFSTR("%@.%ld"), bundleIdentifier, getpid());
+	else
+		messagePortName = CFStringCreateCopy(NULL, bundleIdentifier);
+		
+	if(messagePortName == NULL)
+		return memFullErr;
+
+	if(messagePortName) 
+		mMessagePort = CFMessagePortCreateLocal(NULL, messagePortName, ReceiveCallback, &messageContext, &messageShouldFree);
+
+	CFRelease(messagePortName);
+
+	if(mMessagePort == NULL)
+		return destPortErr;
+		
+	// Set up to receive messages from the controller
+	if((mMessageSource = CFMessagePortCreateRunLoopSource(NULL, mMessagePort, 0)) != NULL &&
+	   (mainLoop = GetMainEventLoop()) != NULL)
+	{
+		OSErr 			err;
+		AEDesc 			desc;
+		OSType 			sig = 'SCPM';
+
+		CFRunLoopAddSource((CFRunLoopRef)GetCFRunLoopFromEventLoop(mainLoop), mMessageSource, kCFRunLoopCommonModes);
+		
+		// Tell the patch code that it has officially been started.
+		err = AEBuildAppleEvent(kEventClassSCPatchMessenger, kEventSCPatchStart,
+								typeApplSignature, &sig, sizeof(sig),
+								kAutoGenerateReturnID, kAnyTransactionID,
+								&desc, NULL, "");
+		ReceiveMessage(&desc);
+	}
+	else
+	{
+		CFRelease(mMessagePort);
+		mMessagePort = NULL;
+	}
+	
+	return err;
+}
+
+//-------------------------------------------------------------------------------------------------------------    						
+OSErr SCPatchMessenger::StopListening(void)
+{
+	EventLoopRef	mainLoop;
+	OSErr 			err;
+	AEDesc 			desc;
+	OSType 			sig = 'SCPM';
+
+	if(mMessageSource && (mainLoop = GetMainEventLoop()) != NULL)
+	{
+		// Tell the patch code that it's about to be stopped.
+		err = AEBuildAppleEvent(kEventClassSCPatchMessenger, kEventSCPatchStop,
+								typeApplSignature, &sig, sizeof(sig),
+								kAutoGenerateReturnID, kAnyTransactionID,
+								&desc, NULL, "");
+		ReceiveMessage(&desc);
+
+		CFRunLoopRemoveSource((CFRunLoopRef)GetCFRunLoopFromEventLoop(mainLoop), mMessageSource, kCFRunLoopCommonModes);
+		CFRelease(mMessageSource);
+		mMessageSource = NULL;
+	}
+	
+	if(mMessagePort)
+	{
+		CFRelease(mMessagePort);
+		mMessagePort = NULL;
+	}
+	return noErr;
+}
+
+//-------------------------------------------------------------------------------------------------------------
+OSErr SCPatchMessenger::SendPing(CFStringRef bundleIdentifier, ProcessSerialNumber *psn)
+{
+	OSErr 			err;
+	AEDesc 			desc;
+	OSType 			sig = 'SCPM';
+
+	err = AEBuildAppleEvent(kSCMessageClass, kSCPing,
+							typeApplSignature, &sig, sizeof(sig),
+							kAutoGenerateReturnID, kAnyTransactionID,
+							&desc, NULL, "");
+
+	if(err == noErr)
+		err = SendMessage(bundleIdentifier, psn, &desc, false);
+
+	return err;
+}
+
+//-------------------------------------------------------------------------------------------------------------
+OSErr SCPatchMessenger::SendMessage(CFStringRef bundleIdentifier,
+						ProcessSerialNumber *psn,
+						AEEventClass evtClass, AEEventID evtID,
+						const char *paramsFmt, ...)
+{
+	OSErr 			err;
+	AEDesc 			desc;
+	va_list			args;
+	OSType 			sig = 'SCPM';
+
+	va_start(args, paramsFmt);
+	// fprintf(stderr, "Sending message %.4s:%.4s\n", &evtClass, &evtID);
+	err = vAEBuildAppleEvent(evtClass, evtID,
+							typeApplSignature, &sig, sizeof(sig),
+							kAutoGenerateReturnID, kAnyTransactionID,
+							&desc, NULL, paramsFmt, args);
+	va_end(args);
+
+	if(err == noErr)
+		err = SendMessage(bundleIdentifier, psn, &desc, mThreaded);
+	
+	return err;
+}
+
+
+//-------------------------------------------------------------------------------------------------------------
+OSErr SCPatchMessenger::SendMessage(CFStringRef bundleIdentifier, 
+						ProcessSerialNumber *psn, 
+						const AppleEvent *theAE,
+						Boolean threaded)
+{
+	OSErr 				err;
+	pid_t				pid = 0;
+	AEMessageInfo		*info;
+
+	if(psn && (err = GetProcessPID(psn, &pid)) != noErr)
+		return err;
+	
+	// If we don't succeed or get an error, there's not enough memory
+	err = memFullErr;
+	
+	if((info = (AEMessageInfo *)NewPtrClear(sizeof(AEMessageInfo))) != NULL &&
+	   (info->descSize = AEGetDescDataSize(theAE)) > 0 && 
+       (info->descData = NewPtr(info->descSize)) != NULL &&
+       AEGetDescData(theAE, info->descData, info->descSize) == noErr)
+  	{
+   		if(pid)
+			info->portName = CFStringCreateWithFormat(NULL, NULL, CFSTR("%@.%ld"), bundleIdentifier, pid);
+		else
+			info->portName = CFStringCreateCopy(NULL, bundleIdentifier);
+		
+		if(info->portName)
+		{
+			info->threaded = threaded;
+
+			if(!threaded)
+			{
+				err = SendMessage(info);
+				DisposePtr(info->descData);
+				DisposePtr((Ptr)info);
+			}
+			else if((err = QueueMessage(info)) != noErr)
+			{
+				err = queueFull;
+			}
+			
+		}
+	}
+
+	return err;
+}
+
+//-------------------------------------------------------------------------------------------------------------
+OSErr SCPatchMessenger::SendMessage(AEMessageInfo *info)
+{
+	SInt32				result = kCFMessagePortTransportError;
+	OSErr 				err = noErr;
+	CFDataRef			dataRef;
+	CFMessagePortRef	portRef;
+
+	if((dataRef = CFDataCreate(NULL, (unsigned char*)info->descData, info->descSize)) != NULL)
+	{
+	   if((portRef = CFMessagePortCreateRemote(NULL, info->portName)) != NULL)
+		{
+			result = CFMessagePortSendRequest(portRef, kSCMessageClass, dataRef, info->threaded ? 0.01 : 5, 0, NULL, NULL);
+			CFRelease(portRef);
+		}
+		else
+		{
+			err = destPortErr;
+		}
+		CFRelease(dataRef);
+	}
+	else
+	{
+		err = memFullErr;
+	}
+	
+	// If we're not going to retry, if we've retried too many times, if the message was sent successfully, 
+	// or there was some unrecoverable error like destPortErr (no one's listening) give up and let the
+	// error pass to the thread loop so it can clean up.
+	if(!info->threaded  || info->retryCount >= mMessageRetryLimit || 
+	   (err == noErr && result == kCFMessagePortSuccess) || 
+	    err == destPortErr || err == memFullErr)
+	{
+		if(err == noErr && result != kCFMessagePortSuccess)
+			err = (result == kCFMessagePortSendTimeout ? noResponseErr : networkErr);
+#if 0
+		if(err != noErr || result != kCFMessagePortSuccess)
+			syslog(LOG_ALERT, "%d: Message to %s failed (err = %d result = %d)\n", getpid(), CFStringGetCStringPtr(info->portName, kCFStringEncodingMacRoman), err, result);
+		else
+			syslog(LOG_ALERT, "%d: Message sent to %s\n", getpid(), CFStringGetCStringPtr(info->portName, kCFStringEncodingMacRoman));
+			
+#endif
+	}
+	else if(info->threaded)	// drop the sending thread's priority and hang around for mMessageRetryInterval
+	{
+		int					policy;
+		struct sched_param 	param;
+		struct timeval		startTime, endTime;
+		
+		info->retryCount++;
+		pthread_getschedparam(pthread_self(), &policy, &param);
+		param.sched_priority = sched_get_priority_min(policy);
+		pthread_setschedparam(pthread_self(), policy, &param);
+		gettimeofday(&startTime, NULL);
+		for(;;)
+		{
+			gettimeofday(&endTime, NULL);
+			if((endTime.tv_sec - startTime.tv_sec) * 1000000L + (endTime.tv_usec - startTime.tv_usec) > 
+			   mMessageRetryInterval * 1000000)
+			{
+				// syslog(LOG_ALERT, "%d: waiting to resend on %s (%d)\n", 
+					   // getpid(), CFStringGetCStringPtr(info->portName, kCFStringEncodingMacRoman), info->retryCount);
+				break;
+			}
+		}
+		
+		err = channelBusy;
+	}
+	
+	return err;
+}
+
+//-------------------------------------------------------------------------------------------------------------
+void *SCPatchMessenger::SendThreadEntryPoint(void *infoPtr)
+{
+	SCPatchMessenger	*self = (SCPatchMessenger *)infoPtr;
+	AEMessageInfo		*info;
+	OSStatus 			err;
+
+	while((info = self->GetNextMessage(pthread_self())) != NULL)
+	{
+		// This will block for mMessageRetryInterval if the send fails
+		err = self->SendMessage(info);
+		
+		// If we've retried too many times, if the message was sent successfully, or if there
+		//  was some unrecoverable error like destPortErr (no one's listening) give up.
+		if(err == noErr || err == destPortErr || err == memFullErr || err == noResponseErr)
+		{
+			if((info = self->DequeueMessage(pthread_self())) != NULL)
+			{
+				CFRelease(info->portName);
+				DisposePtr(info->descData);
+				DisposePtr((Ptr)info);
+			}
+		}
+	}
+	
+	return (void *)err;
+}
+
+//-------------------------------------------------------------------------------------------------------------
+OSErr SCPatchMessenger::QueueMessage(AEMessageInfo *info)
+{
+	CFMutableArrayRef	queue;
+	OSErr				result = noErr;
+	
+	pthread_mutex_lock(&mMessageQueueMutex);
+	
+	if((queue = (CFMutableArrayRef)CFDictionaryGetValue(mMessageQueueDict, info->portName)) == NULL)
+	{
+		if((queue = CFArrayCreateMutable(NULL, 0, NULL)) != NULL)
+		{
+			pthread_t	messageThread;
+
+			CFDictionaryAddValue(mMessageQueueDict, info->portName, queue);
+			pthread_create(&messageThread, NULL, SendThreadEntryPoint, (void *)this);
+			pthread_detach(messageThread);
+			CFDictionaryAddValue(mMessageThreadDict, messageThread, info->portName);
+		}
+	}
+	
+	if(queue)
+		CFArrayAppendValue(queue, info);
+	else
+		result = queueFull;
+
+	pthread_mutex_unlock(&mMessageQueueMutex);
+	return result;
+}
+
+//-------------------------------------------------------------------------------------------------------------
+AEMessageInfo *SCPatchMessenger::GetNextMessage(pthread_t threadID)
+{
+	CFMutableArrayRef	queue;
+	CFStringRef			queueName;
+	AEMessageInfo		*result = NULL;
+	
+	pthread_mutex_lock(&mMessageQueueMutex);
+
+	if((queueName = (CFStringRef)CFDictionaryGetValue(mMessageThreadDict, threadID)) != NULL)
+		if((queue = (CFMutableArrayRef)CFDictionaryGetValue(mMessageQueueDict, queueName)) != NULL)
+			if(CFArrayGetCount(queue) > 0)
+				result = (AEMessageInfo *)CFArrayGetValueAtIndex(queue, 0);
+
+	pthread_mutex_unlock(&mMessageQueueMutex);
+	
+	return result;
+}
+
+//-------------------------------------------------------------------------------------------------------------
+AEMessageInfo *SCPatchMessenger::DequeueMessage(pthread_t threadID)
+{
+	CFMutableArrayRef	queue;
+	CFStringRef			queueName;
+	Boolean				stopThread = false;
+	AEMessageInfo		*result = NULL;
+	
+	pthread_mutex_lock(&mMessageQueueMutex);
+
+	if((queueName = (CFStringRef)CFDictionaryGetValue(mMessageThreadDict, threadID)) != NULL &&
+	   (queue = (CFMutableArrayRef)CFDictionaryGetValue(mMessageQueueDict, queueName)) != NULL)
+	{
+		if(CFArrayGetCount(queue) > 0)
+		{
+			result = (AEMessageInfo *)CFArrayGetValueAtIndex(queue, 0);
+			CFArrayRemoveValueAtIndex(queue, 0);
+		}
+		if(CFArrayGetCount(queue) == 0)
+		{
+			CFDictionaryRemoveValue(mMessageThreadDict, threadID);
+			CFDictionaryRemoveValue(mMessageQueueDict, queueName);
+			stopThread = true;
+		}
+	}
+
+	pthread_mutex_unlock(&mMessageQueueMutex);
+	
+	if(stopThread)
+		pthread_cancel(threadID);
+	
+	return result;
+}
+
+//-------------------------------------------------------------------------------------------------------------
+CFDataRef SCPatchMessenger::ReceiveCallback(CFMessagePortRef local, 
+						SInt32 message, 
+						CFDataRef dataRef, 
+						void *info)
+{
+	#pragma unused(local)
+	
+	SCPatchMessenger	*self = (SCPatchMessenger *)info;
+	Ptr					descData = NULL;
+	AEDesc				desc;
+	long				length;
+	
+	// fprintf(stderr, "%d: Receiving started\n", getpid());
+	if(message == kSCMessageClass)
+	{
+	    if((length = CFDataGetLength(dataRef)) > 0 && (descData = NewPtr(length)) != NULL)
+	    {
+			CFDataGetBytes(dataRef, CFRangeMake(0, length), (unsigned char *)descData);
+
+			if(AECreateDesc(typeAppleEvent, descData, length, &desc) == noErr)
+			{
+				// fprintf(stderr, "%d: handling message\n", getpid());
+				if (self->HandleMessage(&desc) != noErr)
+					self->ReceiveMessage(&desc);
+				// fprintf(stderr, "%d: done handling message\n", getpid());
+				AEDisposeDesc(&desc);
+			}
+			else
+			{
+				fprintf(stderr, "%d: Error %d building AppleEvent", getpid(), memFullErr);
+			}
+		}
+	}
+
+	if(descData)
+		DisposePtr(descData);
+	
+	// fprintf(stderr, "%d: Receiving finished\n", getpid());
+	return NULL;
+}
+
Index: trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchMessenger.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchMessenger.h	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchMessenger.h	(revision 153)
@@ -0,0 +1,96 @@
+#pragma once
+
+extern "C" 
+{
+#include <pthread.h> 
+}
+
+#include <CoreFoundation/CoreFoundation.h> 
+#include "SCPatchCommon.h"
+#include "SCPatchMessages.h"
+
+#define	DEFAULT_MESSAGE_RETRY_LIMIT		100 	// Give up after 5 seconds
+#define	DEFAULT_MESSAGE_RETRY_INTERVAL	.05
+
+// These AppleEvents get sent to ReceiveMessage after StartListening and
+// before StopListening, respectively.
+const OSType	kEventClassSCPatchMessenger = 'SCPm';
+const OSType	kEventSCPatchStart			= 'strt';
+const OSType	kEventSCPatchStop			= 'stop';
+
+typedef struct
+{
+	Boolean				threaded;
+	UInt32				retryCount;
+	Ptr					descData;
+	UInt32				descSize;
+	CFStringRef			portName;
+} AEMessageInfo;
+
+
+class SCPatchMessenger
+{
+
+  public:
+    SCPatchMessenger(void);
+    virtual ~SCPatchMessenger(void);
+    
+    void 				SetMessageRetryInterval(float interval) { mMessageRetryInterval = interval; }
+    float				GetMessageRetryInterval(void) { return mMessageRetryInterval; }
+    
+    void 				SetMessageRetryLimit(UInt32 limit) { mMessageRetryLimit = limit; }
+    UInt32				GetMessageRetryLimit(void) { return mMessageRetryLimit; }
+    
+    // Start listening for messages.  If called from a patch, a PSN must be supplied.
+    // When called from a controller, pass NULL for the PSN.
+    OSErr				StartListening(CFStringRef myBundleIdentifier, 
+							Boolean isPatch, Boolean threaded);
+    OSErr				StopListening(void);
+    
+    // When sending from controller to patch, you have to include the PSN to disambiguate
+    // the bundleID (because the same bundle is loaded into multiple apps), but when 
+    // sending from patch back to controller, the PSN can be null, since there's only one
+    // controller running.
+	OSErr 				SendPing(CFStringRef bundleIdentifier, ProcessSerialNumber *psn);
+
+	OSErr 				SendMessage(CFStringRef bundleIdentifier,
+							ProcessSerialNumber *psn,
+							AEEventClass evtClass, AEEventID evtID,
+							const char *paramsFmt, ...);
+
+	OSErr 				SendMessage(CFStringRef bundleIdentifier, 
+							ProcessSerialNumber *psn, 
+							const AppleEvent *theAE,
+							Boolean threaded);
+							
+	// Override this to receive messages.
+	virtual void		ReceiveMessage(const AppleEvent *theAE) = 0;
+	
+  protected:
+  	virtual OSErr		HandleMessage(const AppleEvent *) { return eventNotHandledErr; }
+  	
+  private:
+  	// Info for the listening port
+	CFMessagePortRef	mMessagePort;
+	CFRunLoopSourceRef	mMessageSource;
+	
+	// Flags for whether we queue outgoing messages, and whether sending is threaded.
+  	Boolean				mThreaded;
+  	
+	// We have named send queues, where the key is the port name.
+	// Each queue is a CFArray of messages.
+	CFMutableDictionaryRef	mMessageQueueDict;
+	CFMutableDictionaryRef	mMessageThreadDict;
+	
+	pthread_mutex_t 	mMessageQueueMutex;
+	float				mMessageRetryInterval;
+	UInt32				mMessageRetryLimit;
+  	
+	OSErr	 			SendMessage(AEMessageInfo *info);
+	static void 		*SendThreadEntryPoint(void *infoPtr);
+	OSErr	 			QueueMessage(AEMessageInfo *info);
+	AEMessageInfo 		*GetNextMessage(pthread_t threadID);
+	AEMessageInfo 		*DequeueMessage(pthread_t threadID);
+	
+	static CFDataRef 	ReceiveCallback(CFMessagePortRef local, SInt32 message, CFDataRef dataRef, void *info);
+};
Index: trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchPrivate.c
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchPrivate.c	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchPrivate.c	(revision 153)
@@ -0,0 +1,29 @@
+#include "SCPatchPrivate.h"
+
+//-------------------------------------------------------------------------------------------------------------
+char *SCPatchGetStringPointer(SCPatchLoaderParams *params, short patchNumber)
+{
+	char 	*cp = params->patchData[0].urlData;
+	long	ii;
+	
+	for(ii = 0; ii < patchNumber; ii++)
+	{
+		cp += strlen(cp) + 1 + ((long)params->patchData[0].urlData - (long)&params->patchData[0].bundleID);
+	}
+	return cp;
+}
+
+//-------------------------------------------------------------------------------------------------------------
+HFSUniStr255 *SCPatchGetHFSUniStrPointer(SCPatchLoaderParams *params, short patchNumber)
+{
+	HFSUniStr255 	*hp = &params->patchData[0].bundleID;
+	long	ii;
+	
+	for(ii = 0; ii < patchNumber; ii++)
+	{
+		hp = (HFSUniStr255 *)((long)hp + ((long)params->patchData[0].urlData - (long)&params->patchData[0].bundleID));
+		hp = (HFSUniStr255 *)((long)hp + strlen((char *)hp) + 1);
+	}
+	return hp;
+}
+
Index: trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchPrivate.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchPrivate.h	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/SCPatch/Common/SCPatchPrivate.h	(revision 153)
@@ -0,0 +1,39 @@
+#pragma once
+
+#ifdef __cplusplus
+extern "C"
+{
+#endif
+
+#include <Carbon/Carbon.h>
+
+typedef struct SCPatchLoaderData
+{
+	// Bundle ID's are unicode < 255 chars
+	HFSUniStr255		bundleID;
+	// urls are just UTF CStrings
+	char				urlData[0];	
+} SCPatchLoaderData;
+
+
+typedef struct SCPatchLoaderParams
+{
+	short				version;
+	size_t				size;
+	ptrdiff_t			codeOffset;
+	pid_t				parent;
+	HFSUniStr255		parentBundleID;
+
+	// patches are just packed one after another (this has to be
+	// one contiguous chunk for injection into the target process).
+	short				patchCount;
+	SCPatchLoaderData	patchData[0];
+	
+} SCPatchLoaderParams;
+
+char *SCPatchGetStringPointer(SCPatchLoaderParams *params, short patchNumber);
+HFSUniStr255 *SCPatchGetHFSUniStrPointer(SCPatchLoaderParams *params, short patchNumber);
+
+#ifdef __cplusplus
+}
+#endif
Index: trunk/Cocoa/F-Script Anywhere/Source/SCPatch/SCPatchClient/SCPatchClient.cpp
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/SCPatch/SCPatchClient/SCPatchClient.cpp	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/SCPatch/SCPatchClient/SCPatchClient.cpp	(revision 153)
@@ -0,0 +1,66 @@
+#include <mach/mach_init.h>
+extern "C" 
+{
+	#include <mach/thread_act.h>
+	#include <pthread.h> 
+	#include <unistd.h> 
+}
+
+#include <Carbon/Carbon.h>
+#include "mach_inject.h"
+#include "SCPatchClient.h"
+
+#ifdef __MWERKS__
+#pragma export on
+#endif
+
+//-------------------------------------------------------------------------------------------------------------
+mach_error_t	SCPatchInit( SCPatchParams *params )
+{
+	ProcessSerialNumber		psn;
+	mach_error_t 			err = err_none;
+	SCPatchClient			*client = SCPatchClient::GetPatchClientPointer();
+	
+	if(client == NULL)
+	{
+		fprintf(stderr, "SCPc: sGlobalPatchClientInstance is not set!\n");
+		return err_sub(EFAULT);
+	}
+	
+	client->mPatchParams = *params;
+	client->mClientBundleID = CFStringCreateWithCharacters(NULL, params->patchBundleID.unicode, params->patchBundleID.length);
+	client->mControllerBundleID = CFStringCreateWithCharacters(NULL, client->mPatchParams.parentBundleID.unicode, client->mPatchParams.parentBundleID.length);
+	
+	// Just in case
+	if(client->mClientBundleID == NULL || client->mControllerBundleID == NULL)
+		return err_sub(ENOMEM);
+
+	if(client->Initialize(client->mClientBundleID, client->mControllerBundleID, getpid()) != noErr)
+		return err_threadEntry_init_failed;
+	
+	// Create a port to receive messages from our patch controller
+	if((err = client->StartListening(client->mClientBundleID, true, true)) != noErr)
+		return err_threadEntry_init_failed;
+	
+	if((err = GetCurrentProcess(&psn)) != noErr ||
+	   (err = client->SendMessage(client->mControllerBundleID, NULL, kSCMessageClass, kSCPatchSuccess, 
+								  "bndl: TEXT(@), proc: psn (@)", 
+								  CFStringGetCStringPtr(client->mClientBundleID, kCFStringEncodingMacRoman),
+								  sizeof(ProcessSerialNumber), &psn)) != noErr)
+		return err_threadEntry_init_failed;
+
+	return noErr; 
+}
+#ifdef __MWERKS__
+#pragma export off
+#endif
+
+//-------------------------------------------------------------------------------------------------------------
+SCPatchClient::SCPatchClient(void)
+{
+}
+
+//-------------------------------------------------------------------------------------------------------------
+SCPatchClient::~SCPatchClient(void)
+{
+}
Index: trunk/Cocoa/F-Script Anywhere/Source/SCPatch/SCPatchClient/SCPatchClient.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/SCPatch/SCPatchClient/SCPatchClient.h	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/SCPatch/SCPatchClient/SCPatchClient.h	(revision 153)
@@ -0,0 +1,33 @@
+#pragma once
+
+#include "SCPatchMessenger.h"
+#include "SCPatchCommon.h"
+
+class SCPatchClient : public SCPatchMessenger
+{
+ 	friend mach_error_t	SCPatchInit(SCPatchParams *params);
+ 	friend mach_error_t ThreadEntryPoint(SCPatchParams *params);
+
+ public:
+
+  	SCPatchClient(void);
+  	~SCPatchClient(void);
+
+	static SCPatchClient	*GetPatchClientPointer(void) { return sGlobalPatchClientInstance; }
+	
+	virtual OSErr			Initialize(CFStringRef /* clientBundleID */, 
+									   CFStringRef /* controllerBundleID */, 
+									   pid_t /* pid */) { return noErr; }
+	
+	CFStringRef				GetMyBundleID(void) { return mClientBundleID; }
+	CFStringRef				GetControllerBundleID(void) { return mControllerBundleID; }
+	
+  protected:
+
+	// In your main file, you must allocate a global instance of your
+	// SCPatchClient subclass and initialize this pointer to it:
+	static SCPatchClient	*sGlobalPatchClientInstance;
+	
+	SCPatchParams			mPatchParams;
+	CFStringRef				mClientBundleID, mControllerBundleID;
+};
Index: trunk/Cocoa/F-Script Anywhere/Source/SCPatch/SCPatchController/SCPatchContext.cpp
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/SCPatch/SCPatchController/SCPatchContext.cpp	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/SCPatch/SCPatchController/SCPatchContext.cpp	(revision 153)
@@ -0,0 +1,106 @@
+#include "SCPatchContext.h"
+
+/* --------------------------------------------------------------------------------	*/
+bool operator< (const MacPSN& x, const MacPSN& y)
+{
+	if(x.psn.highLongOfPSN < y.psn.highLongOfPSN)
+		return true;
+	else if(x.psn.highLongOfPSN == y.psn.highLongOfPSN)
+		return (x.psn.lowLongOfPSN < y.psn.lowLongOfPSN);
+	else
+		return false;
+}
+
+/* --------------------------------------------------------------------------------	*/
+bool operator==(const MacPSN& x, const MacPSN& y)
+{
+	return (x.psn.highLongOfPSN == y.psn.highLongOfPSN &&
+	   		x.psn.lowLongOfPSN  == y.psn.lowLongOfPSN);	
+}
+
+/* --------------------------------------------------------------------------------	*/
+SCPatchContext::SCPatchContext(ProcessSerialNumber *inPSN, SInt32 inPID, OSType inCreator)
+{
+	psn = *inPSN;
+	pid = inPID;
+	path = NULL;
+	name = NULL;
+	creator = inCreator;
+	flags = 0;
+}
+
+/* --------------------------------------------------------------------------------	*/
+SCPatchContext::SCPatchContext(const SCPatchContext &toCopy)
+{
+	psn = toCopy.psn;
+	pid = toCopy.pid;
+	flags = toCopy.flags;
+	creator = toCopy.creator;
+	if((path = toCopy.path) != NULL)
+		CFRetain(path);
+	if((name = toCopy.name) != NULL)
+		CFRetain(name);
+}
+
+/* --------------------------------------------------------------------------------	*/
+/* --------------------------------------------------------------------------------	*/
+SCPatchContextList::SCPatchContextList(void) : contexts()
+{
+}
+
+/* --------------------------------------------------------------------------------	*/
+SCPatchContextList::~SCPatchContextList(void)
+{
+}
+
+/* --------------------------------------------------------------------------------	*/
+SCPatchContextRef SCPatchContextList::NewContext(ProcessSerialNumber *inPSN, 
+											 SInt32 inPID, OSType inCreator)
+{
+	SCPatchContextRef		zeroResult = { 0 };
+	SCPatchContextRef		result;
+	
+	try
+	{
+		MacPSN              macPSN(inPSN);
+		SCPatchContext      patchContext(inPSN, inPID, inCreator);
+		SCPatchContextPair	newContext(macPSN, patchContext);
+
+		contexts.insert(newContext);
+		result = *inPSN;
+	}
+	catch(...)
+	{
+		result = zeroResult;
+	}
+	return result;
+}
+
+/* --------------------------------------------------------------------------------	*/
+SCPatchContext *SCPatchContextList::GetContext(ProcessSerialNumber *inPSN)
+{
+	SCPatchContextIterator			iter;
+	
+	iter = contexts.find(MacPSN(inPSN));
+	if(iter != contexts.end())
+		return &(*iter).second;
+	else
+		return NULL;
+}
+
+/* --------------------------------------------------------------------------------	*/
+SCPatchContext *SCPatchContextList::GetContext(OSType inCreator)
+{
+	SCPatchContextIterator			iter;
+	
+	for(iter = contexts.begin(); iter != contexts.end(); iter++)
+		if(iter->second.creator == inCreator)
+			return &(*iter).second;
+	return NULL;
+}
+
+/* --------------------------------------------------------------------------------	*/
+void SCPatchContextList::DeleteContext(ProcessSerialNumber *inPSN)
+{
+	contexts.erase(MacPSN(inPSN));
+}
Index: trunk/Cocoa/F-Script Anywhere/Source/SCPatch/SCPatchController/SCPatchContext.h
===================================================================
--- trunk/Cocoa/F-Script Anywhere/Source/SCPatch/SCPatchController/SCPatchContext.h	(revision 153)
+++ trunk/Cocoa/F-Script Anywhere/Source/SCPatch/SCPatchController/SCPatchContext.h	(revision 153)
@@ -0,0 +1,69 @@
+#ifndef _SCPATCHCONTEXT_
+#define _SCPATCHCONTEXT_
+
+#ifdef __MWERKS__
+	#include <utility.h>
+	#include <iterator.h>
+	#include <map.h>
+#else
+	#include <utility>
+	#include <iterator>
+	#include <map>
+#endif
+
+#include <Carbon/Carbon.h>
+
+//-------------------------------------------------------------------------------------------------------------
+class MacPSN
+{
+  public:
+	ProcessSerialNumber	psn;
+
+	MacPSN(ProcessSerialNumber *inPSN) { psn = *inPSN; }
+	~MacPSN(void) { };
+	
+};
+
+//-------------------------------------------------------------------------------------------------------------
+bool operator< (const MacPSN& x, const MacPSN& y);
+bool operator==(const MacPSN& x, const MacPSN& y);
+
+//-------------------------------------------------------------------------------------------------------------
+class SCPatchContext
+{
+  public:
+	ProcessSerialNumber	psn;
+	SInt32				pid;
+	OSType				creator;
+	CFStringRef			path;
+	CFStringRef			name;
+	UInt32				flags;
+	  	
+  	SCPatchContext(ProcessSerialNumber *inPSN, SInt32 inPID, OSType creator);
+  	SCPatchContext(const SCPatchContext &);
+  	~SCPatchContext(void) { }
+};
+
+typedef ProcessSerialNumber								SCPatchContextRef;
+typedef std::multimap<MacPSN, SCPatchContext>::iterator	SCPatchContextIterator;
+typedef std::pair<MacPSN, SCPatchContext>				SCPatchContextPair;
+
+class SCPatchContextList
+{
+  private:
+    std::multimap<MacPSN, SCPatchContext>		contexts;
+	
+  public:
+	SCPatchContextList(void);
+	~SCPatchContextList(void);
+	
+	SCPatchContextRef	NewContext(ProcessSerialNumber *inPSN, SInt32 inPID, OSType inCreator);
+	SCPatchContext		*GetContext(ProcessSerialNumber *inPSN);
+	SCPatchContext		*GetContext(OSType inCreator);
+	void				DeleteContext(ProcessSerialNumber *inPSN);
+	
+	SCPatchContextIterator	begin(void) { return contexts.begin(); }
+	SCPatchContextIterator	end(void) { return contexts.end(); }
+};
+
+#endif
